#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK20x20x20NT0x0x0_a1_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=20, NB=20, KB=20, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=20, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const float *stM = A + 40;
   const float *stN = B + 40;
   const float *pfA = A + lda*M;
   const int incAk = (((lda) << 1));
   const int incAm = 2 - (((lda) << 5)+((lda) << 3)), incAn = -40;
   const int incBk = (((ldb) << 1)), incBm = -(((ldb) << 5)+((ldb) << 3));
   #define incBn 8
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 3)) - 40;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3;
   register float m0, m1;
   register float rC0_0, rC0_1, rC0_2, rC0_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         m0 = rA0 * rB0;
         rB3 = pB0[6];
         m1 = rA0 * rB1;

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[2];
         rB2 = pB0[4];
         rB3 = pB0[6];
         rC0_2 += m0;
         m0 = rA0 * rB0;
         rC0_3 += m1;
         m1 = rA0 * rB1;
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB2;
         rC0_1 += m1;
         m1 = rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         rC0_2 += m0;
         rC0_3 += m1;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
