#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_sJIK60x60x60TN0x0x0_aX_b1
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=60, NB=60, KB=60, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=4, ku=60, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const float *stM = A + (60*(lda));
   const float *stN = B + (60*(ldb));
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 60
   const int incAm = ((lda) - 60), incAn = -(60*(lda));
   #define incBk 60
   const int incBm = -60, incBn = (((ldb) << 2));
   #define incCm 1
   const int incCn = (((ldc) << 2)) - 60;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc);
   const float *pA0=A;
   const float *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb);
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3;
   register float rC0_0, rC0_1, rC0_2, rC0_3;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = *pB1;
         rB2 = *pB2;
         rC0_0 += rA0 * rB0;
         rB3 = *pB3;
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rB1 = pB1[1];
         rB2 = pB2[1];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[1];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rB1 = pB1[2];
         rB2 = pB2[2];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[2];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rB1 = pB1[3];
         rB2 = pB2[3];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[3];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rB1 = pB1[4];
         rB2 = pB2[4];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[4];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rB1 = pB1[5];
         rB2 = pB2[5];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[5];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rB1 = pB1[6];
         rB2 = pB2[6];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[6];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[7];
         rB0 = pB0[7];
         rB1 = pB1[7];
         rB2 = pB2[7];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[7];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rB1 = pB1[8];
         rB2 = pB2[8];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[8];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[9];
         rB0 = pB0[9];
         rB1 = pB1[9];
         rB2 = pB2[9];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[9];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rB1 = pB1[10];
         rB2 = pB2[10];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[10];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[11];
         rB0 = pB0[11];
         rB1 = pB1[11];
         rB2 = pB2[11];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[11];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rB1 = pB1[12];
         rB2 = pB2[12];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[12];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[13];
         rB0 = pB0[13];
         rB1 = pB1[13];
         rB2 = pB2[13];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[13];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rB1 = pB1[14];
         rB2 = pB2[14];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[14];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[15];
         rB0 = pB0[15];
         rB1 = pB1[15];
         rB2 = pB2[15];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[15];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rB1 = pB1[16];
         rB2 = pB2[16];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[16];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[17];
         rB0 = pB0[17];
         rB1 = pB1[17];
         rB2 = pB2[17];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[17];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rB1 = pB1[18];
         rB2 = pB2[18];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[18];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[19];
         rB0 = pB0[19];
         rB1 = pB1[19];
         rB2 = pB2[19];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[19];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rB1 = pB1[20];
         rB2 = pB2[20];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[20];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[21];
         rB0 = pB0[21];
         rB1 = pB1[21];
         rB2 = pB2[21];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[21];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rB1 = pB1[22];
         rB2 = pB2[22];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[22];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[23];
         rB0 = pB0[23];
         rB1 = pB1[23];
         rB2 = pB2[23];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[23];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rB1 = pB1[24];
         rB2 = pB2[24];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[24];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[25];
         rB0 = pB0[25];
         rB1 = pB1[25];
         rB2 = pB2[25];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[25];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rB1 = pB1[26];
         rB2 = pB2[26];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[26];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[27];
         rB0 = pB0[27];
         rB1 = pB1[27];
         rB2 = pB2[27];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[27];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rB1 = pB1[28];
         rB2 = pB2[28];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[28];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[29];
         rB0 = pB0[29];
         rB1 = pB1[29];
         rB2 = pB2[29];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[29];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rB1 = pB1[30];
         rB2 = pB2[30];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[30];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[31];
         rB0 = pB0[31];
         rB1 = pB1[31];
         rB2 = pB2[31];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[31];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rB1 = pB1[32];
         rB2 = pB2[32];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[32];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[33];
         rB0 = pB0[33];
         rB1 = pB1[33];
         rB2 = pB2[33];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[33];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rB1 = pB1[34];
         rB2 = pB2[34];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[34];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[35];
         rB0 = pB0[35];
         rB1 = pB1[35];
         rB2 = pB2[35];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[35];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rB1 = pB1[36];
         rB2 = pB2[36];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[36];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[37];
         rB0 = pB0[37];
         rB1 = pB1[37];
         rB2 = pB2[37];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[37];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rB1 = pB1[38];
         rB2 = pB2[38];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[38];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[39];
         rB0 = pB0[39];
         rB1 = pB1[39];
         rB2 = pB2[39];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[39];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rB1 = pB1[40];
         rB2 = pB2[40];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[40];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[41];
         rB0 = pB0[41];
         rB1 = pB1[41];
         rB2 = pB2[41];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[41];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rB1 = pB1[42];
         rB2 = pB2[42];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[42];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[43];
         rB0 = pB0[43];
         rB1 = pB1[43];
         rB2 = pB2[43];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[43];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rB1 = pB1[44];
         rB2 = pB2[44];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[44];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[45];
         rB0 = pB0[45];
         rB1 = pB1[45];
         rB2 = pB2[45];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[45];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rB1 = pB1[46];
         rB2 = pB2[46];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[46];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[47];
         rB0 = pB0[47];
         rB1 = pB1[47];
         rB2 = pB2[47];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[47];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[48];
         rB0 = pB0[48];
         rB1 = pB1[48];
         rB2 = pB2[48];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[48];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[49];
         rB0 = pB0[49];
         rB1 = pB1[49];
         rB2 = pB2[49];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[49];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[50];
         rB0 = pB0[50];
         rB1 = pB1[50];
         rB2 = pB2[50];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[50];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[51];
         rB0 = pB0[51];
         rB1 = pB1[51];
         rB2 = pB2[51];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[51];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[52];
         rB0 = pB0[52];
         rB1 = pB1[52];
         rB2 = pB2[52];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[52];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[53];
         rB0 = pB0[53];
         rB1 = pB1[53];
         rB2 = pB2[53];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[53];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[54];
         rB0 = pB0[54];
         rB1 = pB1[54];
         rB2 = pB2[54];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[54];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[55];
         rB0 = pB0[55];
         rB1 = pB1[55];
         rB2 = pB2[55];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[55];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[56];
         rB0 = pB0[56];
         rB1 = pB1[56];
         rB2 = pB2[56];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[56];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[57];
         rB0 = pB0[57];
         rB1 = pB1[57];
         rB2 = pB2[57];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[57];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[58];
         rB0 = pB0[58];
         rB1 = pB1[58];
         rB2 = pB2[58];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[58];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rA0 = pA0[59];
         rB0 = pB0[59];
         rB1 = pB1[59];
         rB2 = pB2[59];
         rC0_0 += rA0 * rB0;
         rB3 = pB3[59];
         rC0_1 += rA0 * rB1;
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         pA0 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pA0 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pA0 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
