#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK0x0x24NT1x1x1_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=0, NB=0, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (Mb);
   const float *stN = B + (Nb);
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 4)+((lda) << 3)), incAn = -(Mb);
   const int incBk = (ldb), incBm = -(((ldb) << 4)+((ldb) << 3));
   #define incBn 1
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=24; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK0x0x24NT0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=0, NB=0, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=2, ku=1, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   const int Nb = (N>>1)<<1;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (Mb);
   const float *stN = B + (Nb);
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 4)+((lda) << 3)), incAn = -(Mb);
   const int incBk = (ldb), incBm = -(((ldb) << 4)+((ldb) << 3));
   #define incBn 2
   #define incCm 1
   const int incCn = (((ldc) << 1)) - (Mb);
   float *pC0=C, *pC1=pC0+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1;
   register float rC0_0, rC0_1;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            for (k=24; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rC0_0 += rA0 * rB0;
               rB1 = pB0[1];
               rC0_1 += rA0 * rB1;
               pA0 += incAk;
               pB0 += incBk;
            }
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            pC0 += incCm;
            pC1 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_sJIK0x0x24NT1x1x1_aX_bX(M, k, 24, alpha, ca, lda, cb + (Nb), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
