#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK24x24x24TN0x0x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=24, NB=24, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=2, nu=1, ku=24, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const double *stM = A + (((lda) << 5)+((lda) << 4));
   const double *stN = B + (((ldb) << 5)+((ldb) << 4));
   const double *pfA = A + M;
   #define incAk 48
   const int incAm = ((((((lda) << 1)) - 24) << 1)), incAn = -(((lda) << 5)+((lda) << 4));
   #define incBk 48
   const int incBm = -48, incBn = (((ldb) << 1));
   const int incAk0 = ((incAk) / 24), incBk0 = ((incBk) / 24);
   #define incCm 4
   const int incCn = (((ldc) << 1)) - 48;
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1;
   register double rB0;
   register double m0, m1, m2, m3;
   register double rC0_0, rC1_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         ATL_pfl1W(pC0);
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA1 = *pA1;
         m1 = rA1 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA1[2];
         m2 = rA0 * rB0;
         m3 = rA1 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rA1 = pA1[4];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 = m0;
         m0 = rA0 * rB0;
         rC1_0 = m1;
         m1 = rA1 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rA1 = pA1[6];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[8];
         rB0 = pB0[8];
         rA1 = pA1[8];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[10];
         rB0 = pB0[10];
         rA1 = pA1[10];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[12];
         rB0 = pB0[12];
         rA1 = pA1[12];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[14];
         rB0 = pB0[14];
         rA1 = pA1[14];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[16];
         rB0 = pB0[16];
         rA1 = pA1[16];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[18];
         rB0 = pB0[18];
         rA1 = pA1[18];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[20];
         rB0 = pB0[20];
         rA1 = pA1[20];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[22];
         rB0 = pB0[22];
         rA1 = pA1[22];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[24];
         rB0 = pB0[24];
         rA1 = pA1[24];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[26];
         rB0 = pB0[26];
         rA1 = pA1[26];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[28];
         rB0 = pB0[28];
         rA1 = pA1[28];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[30];
         rB0 = pB0[30];
         rA1 = pA1[30];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[32];
         rB0 = pB0[32];
         rA1 = pA1[32];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[34];
         rB0 = pB0[34];
         rA1 = pA1[34];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[36];
         rB0 = pB0[36];
         rA1 = pA1[36];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[38];
         rB0 = pB0[38];
         rA1 = pA1[38];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[40];
         rB0 = pB0[40];
         rA1 = pA1[40];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[42];
         rB0 = pB0[42];
         rA1 = pA1[42];
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rA0 = pA0[44];
         rB0 = pB0[44];
         rA1 = pA1[44];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rA0 = pA0[46];
         rB0 = pB0[46];
         rA1 = pA1[46];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m2;
         m2 = rA0 * rB0;
         rC1_0 += m3;
         m3 = rA1 * rB0;
         rC0_0 += m0;
         rC1_0 += m1;
         rC0_0 += m2;
         rC1_0 += m3;
         pA0 += incAk;
         pA1 += incAk;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
