#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK0x0x0TN1x1x10_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=10, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const int Kb = (K/10)*10;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((ldb*Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 20
   const int incAm = ((((lda) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   #define incBk 20
   const int incBm = -(((Kb) << 1)), incBn = (((ldb) << 1));
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=0; k < Kb; k += 10) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[18];
            rB0 = pB0[18];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         switch(k = (K-Kb))
         {
         case 1:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            break;
         case 2:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            break;
         case 3:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            break;
         case 4:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            break;
         case 5:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            break;
         case 6:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            break;
         case 7:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            break;
         case 8:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            break;
         case 9:
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[8];
            rB0 = pB0[8];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[10];
            rB0 = pB0[10];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[12];
            rB0 = pB0[12];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[14];
            rB0 = pB0[14];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[16];
            rB0 = pB0[16];
            rC0_0 += rA0 * rB0;
            break;
         case 0: ;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK0x0x0TN0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=0, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=1, ku=10, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const int Mb = (M/6)*6;
   #define Nb N
   const int Kb = (K/10)*10;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((lda*Mb) << 1));
   const double *stN = B + (((ldb*Nb) << 1));
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 20
   const int incAm = ((((((lda) << 2)+((lda) << 1)) - Kb) << 1)), incAn = -(((Mb*lda) << 1));
   #define incBk 20
   const int incBm = -(((Kb) << 1)), incBn = (((ldb) << 1));
   #define incCm 12
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1)), *pA4=pA3+(((lda) << 1)), *pA5=pA4+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+8);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC2_0 = pC0[4];
            rC2_0 *= rA0;
            rC3_0 = pC0[6];
            rC3_0 *= rA0;
            rC4_0 = pC0[8];
            rC4_0 *= rA0;
            rC5_0 = pC0[10];
            rC5_0 *= rA0;
            for (k=0; k < Kb; k += 10) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[14];
               rA3 = pA3[14];
               rA4 = pA4[14];
               rA5 = pA5[14];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[16];
               rA3 = pA3[16];
               rA4 = pA4[16];
               rA5 = pA5[16];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[18];
               rB0 = pB0[18];
               rA1 = pA1[18];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[18];
               rA3 = pA3[18];
               rA4 = pA4[18];
               rA5 = pA5[18];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               pA0 += incAk;
               pA1 += incAk;
               pA2 += incAk;
               pA3 += incAk;
               pA4 += incAk;
               pA5 += incAk;
               pB0 += incBk;
            }
            switch(k = (K-Kb))
            {
            case 1:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 2:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 3:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 4:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 5:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 6:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 7:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 8:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[14];
               rA3 = pA3[14];
               rA4 = pA4[14];
               rA5 = pA5[14];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 9:
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = *pA1;
               rC0_0 += rA0 * rB0;
               rA2 = *pA2;
               rA3 = *pA3;
               rA4 = *pA4;
               rA5 = *pA5;
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA1[2];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[2];
               rA3 = pA3[2];
               rA4 = pA4[2];
               rA5 = pA5[2];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA1[4];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[4];
               rA3 = pA3[4];
               rA4 = pA4[4];
               rA5 = pA5[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA1[6];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[6];
               rA3 = pA3[6];
               rA4 = pA4[6];
               rA5 = pA5[6];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[8];
               rB0 = pB0[8];
               rA1 = pA1[8];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[8];
               rA3 = pA3[8];
               rA4 = pA4[8];
               rA5 = pA5[8];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[10];
               rB0 = pB0[10];
               rA1 = pA1[10];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[10];
               rA3 = pA3[10];
               rA4 = pA4[10];
               rA5 = pA5[10];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[12];
               rB0 = pB0[12];
               rA1 = pA1[12];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[12];
               rA3 = pA3[12];
               rA4 = pA4[12];
               rA5 = pA5[12];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[14];
               rB0 = pB0[14];
               rA1 = pA1[14];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[14];
               rA3 = pA3[14];
               rA4 = pA4[14];
               rA5 = pA5[14];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[16];
               rB0 = pB0[16];
               rA1 = pA1[16];
               rC0_0 += rA0 * rB0;
               rA2 = pA2[16];
               rA3 = pA3[16];
               rA4 = pA4[16];
               rA5 = pA5[16];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               break;
            case 0: ;
            }
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            rC4_0 *= rB0;
            rC5_0 *= rB0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0[8] = rC4_0;
            pC0[10] = rC5_0;
            pC0 += incCm;
            pA0 += incAm;
            pA1 += incAm;
            pA2 += incAm;
            pA3 += incAm;
            pA4 += incAm;
            pA5 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pA1 += incAn;
         pA2 += incAn;
         pA3 += incAn;
         pA4 += incAn;
         pA5 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_zJIK0x0x0TN1x1x10_aX_bX(k, N, K, alpha, ca + (((Mb*lda) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
